/*
Lemonslide is a free web application for a publication of sliders and interactive comics.
LemonSlide 1.1.0 (C) 2015  Guillaume "Goliver" Golay

 This file is part of LemonSlide.

    LemonSlide is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LemonSlide is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

*/


//init

$('#contentimg').hide();
$('.infos').hide();
document.getElementById('menu').style.bottom = "-52px";

var contentAera = document.getElementById('contentimg');
var timeline = document.getElementById('timeline');

function resizeArea(){

	/*var areaW = window.innerWidth + "px";
	var areaH = window.innerHeight + "px";*/

	window.onload=function(){
		contentAera.style.width = "100%";
		contentAera.style.height =	"100%";
	}

	var block = document.getElementById('block');
	block.style.width = "100%";
	block.style.height = "100%";

	var cacheBlock = document.getElementById('cacheBlock');
	cacheBlock.style.width = "100%";
	cacheBlock.style.height = "100%";
}

resizeArea();

function getUrlVar(VarSearch){
    var SearchVar = window.location.search.substring(1);
    var VariableArray = SearchVar.split('&');
    for(var i = 0; i < VariableArray.length; i++){
        var Key = VariableArray[i].split('=');
        if(Key[0] == VarSearch){
            return Key[1];
        }
    }
}

xmlFile = getUrlVar('f') //search the lemonslide xml file

var lsfile = null;
     
if (window.XMLHttpRequest || window.ActiveXObject) {
    if (window.ActiveXObject) {
        try {
            lsfile = new ActiveXObject("Msxml2.XMLHTTP");
        } catch(e) {
            lsfile = new ActiveXObject("Microsoft.XMLHTTP");
        }
    } else {
        lsfile = new XMLHttpRequest(); 
    }
} else {
	//error
}

lsfile.open("GET", "files/" + xmlFile + "/lemonslide.xml",false);
lsfile.send();
lsdoc=lsfile.responseXML;

var pathFiles = "files/" + xmlFile + "/";

//init fullscreen

function isFullscr(){
	return document.mozFullScreen || document.webkitIsFullScreen || document.fullScreen; //or *if*
}

window.onresize = function(){
	if(isFullscr()){
		fullscrBtn.style.backgroundImage = "url('imgsapp/nofullscr.png')";
	}
	else{
		fullscrBtn.style.backgroundImage = "url('imgsapp/fullscr.png')";
	}
	resizeArea();
}

var fullscrMode = false;
var fullscrBtn = document.getElementById('fullscr');

function launchFullscreen(element) {
  if(element.requestFullscreen) {
    element.requestFullscreen();
  } else if(element.mozRequestFullScreen) {
    element.mozRequestFullScreen();
  } else if(element.webkitRequestFullscreen) {
    element.webkitRequestFullscreen();
  } else if(element.msRequestFullscreen) {
    element.msRequestFullscreen();
  }
}

function exitFullscreen() {
  if(document.exitFullscreen) {
    document.exitFullscreen();
  } else if(document.mozCancelFullScreen) {
    document.mozCancelFullScreen();
  } else if(document.webkitExitFullscreen) {
    document.webkitExitFullscreen();
  }
}

fullscrBtn.onclick = function(){
	if(!isFullscr()){
		launchFullscreen(document.documentElement);
	}
	else{
		exitFullscreen();
	}
}

//preload

var timgs = new Array();
var plimgs = new Array();

for(i = 0; i < lsdoc.getElementsByTagName("image").length ; i++){
	plimgs[i] = pathFiles + lsdoc.getElementsByTagName("image")[i].childNodes[0].nodeValue;
}

var totLoad = 0;

for(nil = 0; nil < plimgs.length; nil++){
	timgs[nil] = new Image();
	timgs[nil].onload = function(){
		
		this.src = ""; //release memorycache
		totLoad++;
		if(totLoad == plimgs.length){
			$('#loading').fadeOut(200);
			$('#contentimg').delay(400).fadeIn(200);
			/*$('#menu').delay(400).animate({
				bottom: "-24px",
			},600);*/
		}
	}
	timgs[nil].src = plimgs[nil];
}
	

var totalImg = plimgs.length - 1; //total images for functions
var totImgLoaded = plimgs.length;


var swleft = document.getElementById('swleft');
var swright = document.getElementById('swright');

var espSwleft = document.getElementById('esp-swleft');
var espSwright = document.getElementById('esp-swright');

var contentimg = document.getElementById('contentimg');

var currentImg = 0;

swleft.style.left = "-40px";
swright.style.right = "-40px";
swleft.style.opacity = "0";
swright.style.opacity = "0";

//controls

var opaL = 0.4;
var opaR = 1;
var onBtn = false;

espSwright.onmouseover = function(){
	//onBtn = true;
	swright.style.backgroundImage = "url('imgsapp/swr2.png')";
}

espSwright.onmouseout = function(){
	//onBtn = false;
	swright.style.backgroundImage = "url('imgsapp/swr1.png')";
}

espSwleft.onmouseover = function(){
	//onBtn = true;
	swleft.style.backgroundImage = "url('imgsapp/swl2.png')";
}

espSwleft.onmouseout = function(){
	//onBtn = false;
	swleft.style.backgroundImage = "url('imgsapp/swl1.png')";
}

function opaSwitch(){
	if(currentImg == totalImg){
		opaR = 0.4;
		swright.style.opacity = opaR;
		opaL = 1;
		swleft.style.opacity = opaL;
	}
	else if(currentImg == 0){
		opaL = 0.4;
		swleft.style.opacity = opaL;
		opaR = 1;
		swright.style.opacity = opaR;
	}
	else{
		opaR = 1;
		swright.style.opacity = opaR;
		opaL = 1;
		swleft.style.opacity = opaL;
	}
}


espSwright.onclick = function(){
	if(currentImg != totalImg){
		currentImg++;
		loadImg();
	} 
	else{};
}

espSwleft.onclick = function(){
	if(currentImg != 0){
		currentImg--;
		loadImg();
	}
	else{
	};
}


window.onkeydown = function(event) {
    switch (event.keyCode) {
        case 37:
		espSwleft.onclick();
		break;
        case 39:
		espSwright.onclick();
		break;
    }
};


var mouseX = 0;
var mouseY = 0;

var isActive = false;

function inactive(event){
	
	tmX = event.clientX;
	tmY = event.clientY;
	
	if(tmX == mouseX && tmY == mouseY && onBtn == false){
		$('#swleft').animate({
			left: "-40px",
			opacity: "0",
		},400);
		
		$('#swright').animate({
			right: "-40px",
			opacity: "0",
		},400);
		
		$('#menu').animate({
			bottom: "-54px",
		}, 400);
		
		isActive = false;
	}
	else{
	};
}

function active(){
	
	$('#swleft').animate({
		left: "0px",
		opacity: opaL,
	},400);
	
	$('#swright').animate({
		right: "0px",
		opacity: opaR,
	},400);
	
	$('#menu').animate({
		bottom: "-24px",
	}, 400);
}

$('body').mousemove(function(event){
	mouseX = event.clientX;
	mouseY = event.clientY;
	if(isActive == false){
		active();
		isActive = true;
	}
	else{};
	setTimeout(inactive, 2000, event);
});

var showHelp = false;

document.getElementById('help').onclick = function(){
	if(showHelp == false){
		$('.infos').stop();
		showHelp = true;
		$('.infos').fadeIn(400);
	}
	else{
		$('.infos').stop();
		showHelp = false;
		$('.infos').fadeOut(400);
	}
}

document.getElementById('quitinfos').onclick = function(){
	showHelp = false;
	$('.infos').fadeOut(400);
}


//Display images


function loadImg(){

	opaSwitch();

	var dispCurImg = currentImg + 1;
	
	
	setTimeout(function(){cacheBlock.style.backgroundImage = "url(" + plimgs[currentImg] + ")"}, 100);
	block.style.backgroundImage = "url(" + plimgs[currentImg] + ")";
	document.getElementById('numstat').innerHTML = dispCurImg + " - " + totImgLoaded ;
}

loadImg();